/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	ManifestFactory
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.engine;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import jp.co.ntt.lms.lo.scorm.util.CachedNode;
import jp.co.ntt.lms.lo.scorm.util.Debug;
import jp.co.ntt.lms.lo.scorm.util.SG;
import jp.co.ntt.lms.lo.scorm.util.XMLUtil;
import jp.co.ntt.lms.lo.scorm.util.XPathUtil;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

public class ManifestFactory implements Runnable {
	/** キャッシュの入れ物 */
	private static HashMap cacheHolder = new HashMap();

	/** キャッシュの保持時間(msec) */
	private static long preserveTime;

	/** 唯一の自分自身 */
	private static ManifestFactory self;

	/** キャッシュ破棄スレッド */
	private static Thread discarderThread;

	static {
		try {
			// SGからキャッシュ保持時間を取得する
			String value = SG.get("CacheManifestMinutes");

			// 取得できた場合はmsecに直し、プロパティへ設定する
			if (value != null) {
				try {
					preserveTime = Long.parseLong(value) * 60 * 1000;
				}
				catch (Exception ex) {
					Debug.write(ex);

					preserveTime = 0;
					ex.printStackTrace(System.out);
				}
			}

			// 自分自身を作成する
			new ManifestFactory();
		}
		catch (Exception ex) {
			Debug.write(ex);

			preserveTime = 0;
			ex.printStackTrace(System.out);
		}
	}

	/**
	 * cacheHolderに格納するItem
	 */
	private static class CacheItem {
		/** 破棄時刻 */
		private long discardTime;

		/** キャッシュしているCachedNode */
		private CachedNode node;

		/** キャッシュしているCachedNodeのDOM Document */
		private Document doc;

		/**
		 * 破棄時刻を設定する
		 *
		 * @param discardTime	破棄時刻
		 */
		private void setDiscardTime(long discardTime) {
			this.discardTime = discardTime;
		}

		/**
		 * 破棄時刻を取得する
		 *
		 * @return 破棄時刻
		 */
		private long getDiscardTime() {
			return discardTime;
		}

		/**
		 * CachedNodeを設定する
		 *
		 * @param node	CachedNode
		 */
		private void setNode(CachedNode node) {
			this.node = node;
		}

		/**
		 * CachedNodeを取得する
		 *
		 * @return CachedNode
		 */
		private CachedNode getNode() {
			return node;
		}

		/**
		 * Documentを設定する
		 *
		 * @param doc	Document
		 */
		private void setDocument(Document doc) {
			this.doc = doc;
		}
	}

	/**
	 * デフォルトコンストラクタ
	 */
	private ManifestFactory() {
		self = this;

		if (preserveTime > 0) {
			discarderThread = new Thread(this);
			discarderThread.setDaemon(true);
			discarderThread.start();
		}
	}

	/**
	 * manifestIDから、対応するmanifestのCachedNodeを取得する<br>
	 * 1.manifestIDで指定されたマニフェストがキャッシュ(cacheHolder)に存在しない場合は
	 * manifestNodeパラメータでCachedNodeを作成しキャッシュに追加する。存在した場合は、
	 * 取得できたキャッシュを返却する。<br>
	 * 2.キャッシュに存在しなかった場合、manifestNodeで指定されたNodeに<sequencing>ノード
	 * が1件以上存在するかどうかチェックし、1件も存在しなかった場合は、<sequencing>ノード
	 * の作成を行い、全<item>ノードに以下の内容を追加する。<br>
	 * &nbsp;&nbsp;<pre><imsss:sequencing></pre><br>
	 * &nbsp;&nbsp;&nbsp;&nbsp;<pre><imsss:controlMode flow="true" choice="true"/></pre><br>
	 * &nbsp;&nbsp;<pre></imsss:sequencing></pre><br>
	 *
	 * @param manifestID	マニフェストID
	 * @param manifestNode	マニフェストのノード
	 * @param doc			manifestNodeのオーナドキュメント
	 * @return manifestNodeパラメータで指定されたNodeのCachedNodeを返却する
	 */
	public static CachedNode getCachedNode(String manifestID, Node manifestNode, Document doc)
		throws IOException, ParserConfigurationException, SAXException, TransformerException {

		synchronized (self) {
			CacheItem item = null;

			// キャッシュからCachedNodeを取得する
			if (preserveTime > 0) {
				item = (CacheItem)cacheHolder.get(manifestID);
			}

			// キャッシュに存在しなかった場合
			if (item == null) {
				// キャッシュに追加する
				item = new CacheItem();

				item.setNode(new CachedNode(manifestNode));
				item.setDocument(doc);
				cacheHolder.put(manifestID, item);

				// <sequencing>タグが1つ以上存在するかどうかチェックする
				CachedNode sequencingNode =
					item.getNode().selectSingleNode("organizations/organization//sequencing", false);

				// <sequencing>タグが1つ以上存在しなかった場合
				if (sequencingNode == null) {
					// 全<item>タグを取得する
					CachedNode[] itemNodes =
						item.getNode().selectNodeList(
							"organizations/organization|organizations/organization//item",
							false);

					// 取得できた全<item>タグに<sequencing>タグを追加する
					if (itemNodes != null) {
						Document complementSequencing;

						// カスタマイズされたボタン出力xslへのフルパスを作成する
						StringBuffer complementSequencingFileURL = new StringBuffer();

						complementSequencingFileURL.append(SG.get("ContentsBaseURL"));
						complementSequencingFileURL.append(manifestID);
						complementSequencingFileURL.append(File.separator);
						complementSequencingFileURL.append("_customize");
						complementSequencingFileURL.append(File.separator);
						complementSequencingFileURL.append("ComplementSequencing.xml");

						String complementSequencingFilename = complementSequencingFileURL.toString();

						if (new File(complementSequencingFilename).exists()) {
							BufferedInputStream bis =
								new BufferedInputStream(new FileInputStream(complementSequencingFilename));

							try {
								complementSequencing = XMLUtil.createDocument(bis, false);
							}
							finally {
								bis.close();
							}

							for (int i = 0; i < itemNodes.length; i++) {
								itemNodes[i].getNode().appendChild(
									doc.importNode(complementSequencing.getDocumentElement(), true));
							}
						}
					}
				}
				// <sequencing>タグが1つ以上存在する場合
				else {
					// <sequencingCollection>/<sequencing>を参照している定義されている<sequencing>の
					// マージを行う
					Node[] referedSequencingsNodes =
						XPathUtil.selectSimpleNodeList(manifestNode, "sequencingCollection/sequencing");

					if ((referedSequencingsNodes != null) && (referedSequencingsNodes.length > 0)) {
						Node organizationNode =
							item
								.getNode()
								.selectSingleNode("organizations/organization[@identifier=../@default]")
								.getNode();

						for (int i = 0; i < referedSequencingsNodes.length; i++) {
							String referedSequencingID =
								XPathUtil.selectSingleChildNode(referedSequencingsNodes[i], "@ID").getNodeValue();

							Node[] referingSequencingsNodes =
								XPathUtil.selectNodeList(
									manifestNode,
									"organizations/organization//sequencing[@IDRef='" + referedSequencingID + "']");

							for (int j = 0; j < referingSequencingsNodes.length; j++) {
								Node[] referedSequencingChildNodes =
									XPathUtil.selectChildNodeList(referedSequencingsNodes[i], "*");

								for (int k = 0; k < referedSequencingChildNodes.length; k++) {
									Node node =
										XPathUtil.selectSingleChildNode(
											referingSequencingsNodes[j],
											XPathUtil.getLocalName(referedSequencingChildNodes[k]));

									if (node == null) {
										referingSequencingsNodes[j].appendChild(
											referedSequencingChildNodes[k].cloneNode(true));
									}
								}
							}
						}
					}
				}
			}

			// キャッシュ破棄時刻を設定する
			item.setDiscardTime(System.currentTimeMillis() + preserveTime);

			// キャッシュ破棄スレッドにキャッシュの更新を通知する
			self.notify();

			// CachedNodeを返却する
			return item.getNode();
		}
	}

	/**
	 * キャッシュ破棄スレッド<br>
	 * SGで指定された時間が過ぎてアクセスが行われなかったCachedItemをcacheHolderから取り除く
	 */
	public void run() {
		try {
			ArrayList discardItems = new ArrayList();
			long wackupMillis;

			synchronized (self) {
				while (true) {
					wackupMillis = Long.MAX_VALUE;

					// キャッシュを全て更新し、破棄時刻を過ぎているItemのリストを作成する
					for (Iterator keys = cacheHolder.keySet().iterator(); keys.hasNext();) {
						Object key = keys.next();
						CacheItem item = (CacheItem)cacheHolder.get(key);

						if (item.getDiscardTime() <= System.currentTimeMillis()) {
							discardItems.add(key);
						}
						else {
							if (item.getDiscardTime() < wackupMillis) {
								wackupMillis = item.getDiscardTime();
							}
						}
					}

					// 破棄時刻を過ぎているItemをキャッシュから削除する
					for (int i = 0; i < discardItems.size(); i++) {
						cacheHolder.remove(discardItems.get(i));
					}

					discardItems.clear();

					// 次の破棄イベントが発生するまで待機する
					if (cacheHolder.size() <= 0) {
						self.wait();
					}
					else {
						wackupMillis -= System.currentTimeMillis();

						if (wackupMillis > 0) {
							self.wait(wackupMillis);
						}
					}
				}
			}
		}
		catch (Exception ex) {
			Debug.write(ex);

			ex.printStackTrace(System.out);
		}
	}
}
